/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.crop.clm;

/** Jersey REST client generated for REST resource:CropWadl-xml [clm/crop_service.php]<br>
 *  USAGE:<pre>
 *        ClmCropClient client = new ClmCropClient();
 *        Object response = client.XXX(...);
 *        // do whatever with response
 *        client.close();
 *  </pre>
 * @author merijn
 */
public class ClmCropClient {
    private com.sun.jersey.api.client.WebResource webResource;
    private com.sun.jersey.api.client.Client client;
    private static final String BASE_URI = "http://www.agrosense.nl";
    private static final String APP_KEY = "fk234u5g890vufjnmkl3425j354";

    public ClmCropClient() {
        com.sun.jersey.api.client.config.ClientConfig config = new com.sun.jersey.api.client.config.DefaultClientConfig();
        client = com.sun.jersey.api.client.Client.create(config);
        webResource = client.resource(BASE_URI).path("clm/crop_service.php");
    }

    /**
     * @param responseType Class representing the response
     * @param appKey query parameter[REQUIRED]
     * @return response object (instance of responseType class)
     */
    public <T> T getCrops(Class<T> responseType) throws com.sun.jersey.api.client.UniformInterfaceException {
        return webResource.queryParam("appKey", APP_KEY).accept(javax.ws.rs.core.MediaType.TEXT_XML).get(responseType);
    }

    public void close() {
        client.destroy();
    }
    
}
