/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.crop.clm;

import java.io.ByteArrayInputStream;
import java.util.logging.Logger;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

/**
 * Un marshaler for un marshaling CropMessage objects
 * @author Merijn Zengers
 */
public class ClmUnmarshaller {
    private static final Logger LOGGER = Logger.getLogger("nl.cloudfarming.client.stock.type");    
    private static final String PACKAGE_NAME = "nl.cloudfarming.client.crop.clm";
    
    
    /**
     * Unmarshal String containing xml to a CropMessage object
     * @param XML the String to unmarshall
     * @return A CropMessage entity
     */
    public CropMessage unMarshall(String XML){
        JAXBContext jc;
        CropMessage created = null;
        try {
            jc = JAXBContext.newInstance(PACKAGE_NAME);
            Unmarshaller unmarshaller = jc.createUnmarshaller();
            ByteArrayInputStream in = new ByteArrayInputStream(XML.getBytes());
            
            JAXBElement element = (JAXBElement) unmarshaller.unmarshal(in);
            created = (CropMessage) element.getValue();
        } catch (JAXBException ex) {
            LOGGER.fine("Failed to convert xml from webservice to CropMessage object. " + ex.toString());
        }
        return created;
    }
}
